URL_RANK_DATA="http://zp.vimedia.cn:8998/LiuJiaoTopServlet?value=";
URL_RANK_POST="http://ad.vimedia.cn:8998/AlonePostServlet?value=";
URL_ACTION_GETTOP="getTop";
URL_ACTION_SETUSER="setUser";

var playerInfo=cc.Class.extend({
    appid:"000",
    child:"000",
    coins:"000",
    id:"000",
    imei:"000",
    imsi:"000",
    level:"000",
    lsn:"000",
    nickname:"000",
    phone:"000",
    pid:"000",
    score:"000",
    total:"000",
});

var infoData=cc.Class.extend({
    isuser:false,   //是否是自己
    name:"000",     //名字
    order:0,        //排名
    score:0,        //分数
    bonus:"000",    //奖金
    image:"0",      //头像
});

//奖励信息
var bonusinfo=cc.Class.extend({
    rewardid:[],
    rewardnum:[],
    liqu:false,
    time:"0",
})

var RankData=cc.Class.extend({
    _datalist:[],
    _bonuslist:[],
    ctor:function(){
        this.initData();
    },

    initData:function(){
        for(var i=0;i<3;i++){
            this._datalist.push(new Array());
            this.addVirsualData(i);

            this._bonuslist.push(new bonusinfo);
        }
    },

    //获取排行榜数据
    getRankData:function(key){
        this.reSortRank(key);
        return this._datalist[key].slice(this._datalist[key].length-50,this._datalist[key].length);
    },

    //获取服务器数据
    rankGet:function(url,key,callback){
         var xhr = cc.loader.getXMLHttpRequest();
         xhr.open("GET", url);
         xhr.setRequestHeader("Content-Type","application/x-www-form-urlencoded;charset=UTF-8");
         xhr.onreadystatechange = function(){
             var json= "";
             if (xhr.readyState == 4 && (xhr.status >= 200 && xhr.status <= 207)) {
                 json = JSON.parse(xhr.responseText);
             }
             callback(json);
        };
         xhr.send();
    },

    //向服务器提交数据
    rankPost:function(url,callback){
        var xhr = cc.loader.getXMLHttpRequest();
        xhr.open("GET", url);
        xhr.setRequestHeader("Content-Type","application/x-www-form-urlencoded;charset=UTF-8");
        xhr.onreadystatechange= function(){
            var json= "";
            if (xhr.readyState == 4 && (xhr.status >= 200 && xhr.status <= 207)) {
                json =xhr.responseText;
                callback(json);
            }
        };
        xhr.send();
    },

    //提交分数
    postModelScore:function (score,type) {
        if(type==101){
            type=104;
        }else if(type==103){
            type=105;
        }
        var para = "pid="+ wb.SysConfig.getPrjid()+"&lsn="+ wb.SysConfig.getLsn() +"&imsi="+  wb.SysConfig.getImsi() + "&child="+wb.SysConfig.getMmid()+
            "&appid="+ wb.SysConfig.getAppid()+"&imei="+ wb.SysConfig.getImei() +"&model="+  wb.SysConfig.getMoilemodel() +"&topType="+type+ "&level="+0+
            "&score="+score+"&coins="+0+"&total="+0;
        //var para="pid=220361&lsn=195573809&imsi=0&chlid=0000000000&appid=15665&imei=863784027072352&model=NX507J&topType=101&level=0&score=10000&coins=0&total=0";
        var url=URL_RANK_POST+Base64.encode(para);
        cc.log(url);
        this.rankPost(url, function(response){
            if(response) {
                cc.log("post rankscore success! response:"+response);
            }
        }.bind(this));
    },

    getServerData:function(key){
        var grank=0;
        var topkey=key+101;
        if(key==0){
            topkey==104;
        }else if(key==2){
            topkey==105;
        }
        if(this.getUserData())
           grank=this.getUserData().order;

        var url=URL_RANK_DATA;
        var param="action=";
        param+=URL_ACTION_GETTOP;
        param += "&pid=" +wb.SysConfig.getPrjid();
        param += "&chlid=" + wb.SysConfig.getMmid();
        param += "&lsn=" + wb.SysConfig.getLsn();
        param += "&appid=" + wb.SysConfig.getAppid();
        param += "&phoneModel=" + wb.SysConfig.getMoilemodel();
        param += "&version=" + wb.SysConfig.getAppVersion();
        param += "&grank=" + grank.toString();
        param += "&topType=" + topkey.toString();

        var encode=Base64.encode(param);
        url+=encode;
        cc.log(url)

        this.rankGet(url, key,function(response){
            if(response) {
                this.parseRankData(response,key)
            }
        }.bind(this));
    },

    //解析排行榜数据
    parseRankData:function(result,key){
        if(result.length<=0)
            return;

        //奖品
        var award=result.award;
        if(award){
            var awardnum=result.awardCount;
            this._bonuslist[key].rewardid=ELSGameTool.getInstance().StringToArray(award);
            this._bonuslist[key].rewardnum=ELSGameTool.getInstance().StringToArray(awardnum);
            this._bonuslist[key].time=result.topDt;
            if(result.topDt==ELSGameData.getInstance().getRankBounsTime(key)){
                this._bonuslist[key].liqu=true;
                cc.log("bouns-"+(key+1)+"have lingqu");
            }else{
                this._bonuslist[key].liqu=false;
                cc.log("bouns-"+(key+1)+"don't have lingqu");
            }
        }

        //排行玩家
        var selflist=new Array();
        var otherlist=new Array();
        selflist=result.currList;
        otherlist=result.list;
        if(selflist.length>0){
            var selfdata=selflist[0];
            var data=new infoData();
            data.isuser=true;
            data.name="自己";
            data.score=parseInt(selfdata.score);
            data.bonus=selfdata.total;
            data.image=GameUserInfo.getInstance().getUserTx();
            data.order=0;
            if(this._datalist[key])
                this._datalist[key].push(data);
        }

        if(otherlist.length>0){
            for(var i in otherlist){
                var otherdata=otherlist[i];
                if(otherdata.nickname!="自己"){
                    var data=new infoData();
                    data.isuser=false;
                    data.name=otherdata.nickname;
                    data.score=parseInt(otherdata.score);
                    data.bonus=otherdata.total;
                    data.image=this.getTxByStr(data.name);
                    data.order=0;
                    if(this._datalist[key])
                        this._datalist[key].push(data);
                }
            }
        }
    },

    //获取当前排行榜个人排行
    getUserData:function(key){
        for(var i in this._datalist[key]){
            if(this._datalist[key][i].isuser)
                return this._datalist[key][i];
        }
        return null;
    },

    //添加假数据
    addVirsualData:function(key){
        for (var i = 0; i < 50; i++) {
            var user=new infoData();
            user.isuser = false;
            user.order = i + 1;
            var name=EN_list[wb.randNum(0,25)]+'-';
            for(var k=0;k<5;k++){
                name+=wb.randNum(0,9).toString();
            }
            user.name = name;
            user.score = 500 + i * 150 + parseInt(Math.random()*40);
            user.image=this.getTxByStr(name);

            this._datalist[key].push(user);
        }
    },

    //通过字段的头像
    getTxByStr:function (str) {
        var k1=0;
        if(str.length>=3){
            var key1=str.slice(str.length-3,str.length);
            k1=parseInt(key1);
        }
        if(!k1)
            k1=0;
        return touxiangpng[k1%11];
    },

    //排行榜重新排列
    reSortRank:function (key) {
        var inrank=false;       //是否在排行榜内
        for(var i in this._datalist[key]){
            if(this._datalist[key][i].isuser){
                inrank=true;
                var num=ELSGameData.getInstance().getRankHightScore(101+key);
                if(num<this._datalist[key][i].score){
                    num=this._datalist[key][i].score;
                    ELSGameData.getInstance().setRankHightScore(num,101+key);
                }
                this._datalist[key][i].score=num;
                break;
            }
        }

        if(!inrank){
            var self=new infoData();
            self.isuser=true;
            self.order=51;
            self.name="自己";
            self.score=ELSGameData.getInstance().getRankHightScore(101+key);
            self.image=touxiangpng[0];
            this._datalist[key].push(self);
        }

        for(var i=0;i<this._datalist[key].length;i++){
            for(var j=i+1;j<this._datalist[key].length;j++){
                if(this._datalist[key][i].score>this._datalist[key][j].score){
                    var temp=this._datalist[key][i];
                    this._datalist[key][i]=this._datalist[key][j];
                    this._datalist[key][j]=temp;
                }
            }
        }

        var dd=1;
        for(var i=this._datalist[key].length-1;i>=0;i--){
            this._datalist[key][i].order=dd;
            dd++;
        }
    },
});

RankData._instance=null;
RankData.getInstance=function(){
    if(!RankData._instance){
        RankData._instance=new RankData();
    }
    return RankData._instance;
};
