LIUJIAO_SIZE_WIDTH=69;
LIUJIAO_SIZE_Height=58;
LIUJIAO_WIDTH=9;
LIUJIAO_HEIGHT=9;
LIUJIAO_CHESS_SCALE=1.0;
var LiujiaoLayer=cc.Layer.extend({
    _manager:null,
    ctor:function () {
        this._super();

        ELSGameLogic.getInstance().setGameType(GameType.Type_LIUJIAO);
        this.initLayer();
        this._manager=new LjManager();
        this.addChild(this._manager);
        this.dataUpdate();
        this.schedule(this.dataUpdate,0.1);
        ELSGameLogic.getInstance().addReturnPage(2);
    },

    initLayer:function () {
        csb=ccs.load(res.LiujiaoScene_json).node;
        this.addChild(csb);
        csb.setContentSize(WINSIZE);
        ccui.helper.doLayout(csb);

        var node=csb.getChildByName("node");

        if(ELSGameLogic.getInstance().isFullScreen()){
            var pos=node.getPosition();
            node.setPositionY(WINSIZE.height-FULLSCENE_HEIGHT);
        }
        // if(ELSGameLogic.getInstance().isIphoneX()){
        //     node.setPositionY(WINSIZE.height*0.94-40);
        // }

        fnt_score=node.getChildByName("recentscore").getChildByName("fnt");
        fnt_highscore=node.getChildByName("hightestscore").getChildByName("fnt");

        wb.FW(node,"pause",function () {
            if(!this.getManager()._guide){
                cc.log("pause.xxx");
                var layer=new PauseLayer();
                this.addChild(layer,100);
                ELSGameTool.getInstance().playVideo(VIDEO[0]);
            }
        }.bind(this));
    },

    getManager:function () {
        return this._manager;
    },

    restart:function () {
        OneZeroTempData.getInstance().clear();
        this.getManager().restart();
    },

    dataUpdate:function (ft) {
        fnt_score.setString(this.getManager().getScore().toString());
        fnt_highscore.setString(ELSGameData.getInstance().getLjHighScore().toString());
    },
})

var LiujiaoScene=cc.Scene.extend({
    onEnter:function () {
        this._super();

        var layer=new LiujiaoLayer();
        this.addChild(layer);
    }
})