var Dhmlayer=BaseLayer.extend({
    _textfield:null,
    _tipinfo:null,
    _tipsp:null,
    _candh:true,
    ctor:function () {
        this._super();
        this.initLayer();
        this.scheduleUpdate();
    },

    initLayer:function () {
        var root=ccs.load(res.dhm_json).node;
        this.getContainer().addChild(root);

        this._textfield=ccui.helper.seekWidgetByName(root,"TextField");
        this._tipsp=ccui.helper.seekWidgetByName(root,"tipsp");
        this._tipinfo=new cc.LabelTTF("","Arial",32);
        root.addChild(this._tipinfo)
        var pos=this._textfield.getPosition();
        this._tipinfo.setPosition(cc.p(pos.x,pos.y-60));

        //兑换按钮
        wb.FW(root,"sure",function () {
            this.datahandle();
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        //关闭按钮
        wb.FW(root,"cha",function () {
            this.removeFromParent(true);
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));
    },

    //兑换
    datahandle:function () {
        if(!this._candh)
            return;
        this._candh=false;

        var ss=this._textfield.getString();
        if(ss=="10021002"){
            wb.showAppInfoLayer();
            this._candh=true;
            return;
        }

        var data=wb.JCDKEY.use1(ss);
        if(data.getState()==-1){
            this._tipinfo.setString("请联网后重试");
        }else{
            if(data.getState()==1){
                var pricestr=data.getPrice();
                for(var i=0;i<4;i++){
                    if(pricestr==ZSPRICE[i]){
                        ELSGameLogic.getInstance().useIcon(ZSNUM[i]);
                        break;
                    }
                }
            }
            this._tipinfo.setString(data.message);
        }
        this._candh=true;
    },

    update:function (ft) {
        if(this._textfield.getString().length==0)
            this._tipsp.setVisible(true);
        else
            this._tipsp.setVisible(false);
    },
})