
var ELSGameData=cc.Class.extend({
    main_num:0,

    rankHigtScore:[],

    ctor:function(){
        for(var i=0;i<3;i++){
            this.rankHigtScore.push(this.getModelHighScore(i));
        }
    },

    getRankHightScore:function (key) {
        return this.rankHigtScore[key-101];
    },

    setRankHightScore:function (score,key) {
        this.rankHigtScore[key-101]=score;
    },

    //获取道具个数(从0 开始）
    getPropNum:function(id){
        return ELSGameTool.getInstance().getIntegerForKey("ELS_Prop_"+id,0);
    },

    //获取模式最高分
    getModelHighScore:function(type){
        var ret=0;
        if(type==0){
            ret=this.getStarHighScore();
        }else if(type==1){
            ret=this.getTdHighScore();
        }else if(type==2){
            ret=this.getLjHighScore();
        }
        return ret;
    },

    //设置模式最高分
    setModelHighScore:function (score) {
        if(ELSGameLogic.getInstance().getGameType()==GameType.Type_Star)
            this.setStarHighScore(score);
        else if(ELSGameLogic.getInstance().getGameType()==GameType.Type_1010)
            this.setTdHighScore(score);
        else if(ELSGameLogic.getInstance().getGameType()==GameType.Type_LIUJIAO)
            this.setLiujiaoHighScore(score);
    },

    //设置道具个数
    setPropNum:function (id,num) {
        ELSGameTool.getInstance().setIntegerForKey("ELS_Prop_"+id,num);
    },
    changePropNum:function (id,changenum) {
        var prenum=this.getPropNum(id);
        ELSGameTool.getInstance().setIntegerForKey("ELS_Prop_"+id,prenum+changenum);
    },

    //
    getStarHighScore:function () {
        return ELSGameTool.getInstance().getIntegerForKey("ELS_Star_highscore",0);
    },

    setStarHighScore:function (score) {
        if(score>this.getRankHightScore(101)){
            this.setRankHightScore(score,101);
            RankData.getInstance().postModelScore(score,101);
        }
        var hscore=this.getStarHighScore();
        if(score>hscore){
            ELSGameTool.getInstance().setIntegerForKey("ELS_Star_highscore",score);
        }
    },

    //经典模式最高分
    getTetrisHighScore:function () {
        return ELSGameTool.getInstance().getIntegerForKey("ELS_Tetris_highscore",0);
    },

    setTetrisHightScore:function (score) {
        if(score>this.getRankHightScore(101)){
            this.setRankHightScore(score,101);
            RankData.getInstance().postModelScore(score,101);
        }
        var hscore=this.getTetrisHighScore();
        if(score>hscore){
            ELSGameTool.getInstance().getIntegerForKey("ELS_Tetris_highscore",score);
        }
    },

    //拖动模式最高分
    getTdHighScore:function () {
        return ELSGameTool.getInstance().getIntegerForKey("ELS_TD_highscore",0);
    },

    setTdHighScore:function (score) {
        if(score>this.getRankHightScore(102)){
            this.setRankHightScore(score,102);
            RankData.getInstance().postModelScore(score,102);
        }
        var hscore=this.getTdHighScore();
        if(score>hscore){
            ELSGameTool.getInstance().setIntegerForKey("ELS_TD_highscore",score);
        }
    },

    //六角模式最高分
    setLiujiaoHighScore:function (score) {
        if(score>this.getRankHightScore(103)){
            this.setRankHightScore(score,103);
            RankData.getInstance().postModelScore(score,103);
        }
        var hscore=this.getLjHighScore();
        if(score>hscore){
            ELSGameTool.getInstance().setIntegerForKey("ELS_LJ_highscore",score);
        }
    },
    getLjHighScore:function () {
        return ELSGameTool.getInstance().getIntegerForKey("ELS_LJ_highscore",0);
    },

    //方块模式最高分
    getFkHightScore:function(){
        return ELSGameTool.getInstance().getIntegerForKey("ELS_FK_highscore",0);
    },

    setFkHightScore:function(score){
        if(score>this.getRankHightScore(103)){
            this.setRankHightScore(score,103);
            RankData.getInstance().postModelScore(score,103);
        }
        var hscore=this.getFkHightScore();
        if(score>hscore){
            ELSGameTool.getInstance().setIntegerForKey("ELS_FK_highscore",score);
        }
    },

    //各个模式的存档
    setGameGuide:function (model,bo) {
        ELSGameTool.getInstance().setBoolForKey("ELS_GUIDE_"+model,bo);
    },

    getGameGuide:function (model) {
        return ELSGameTool.getInstance().getBoolForKey("ELS_GUIDE_"+model,true);
    },

    //排行榜的领取时间
    getRankBounsTime:function(type){
        return ELSGameTool.getInstance().getIntegerForKey("ELS_RANBOUNS_"+type,0);
    },
    setRankBounsTime:function(type,time){
        ELSGameTool.getInstance().setIntegerForKey("ELS_RANBOUNS_"+type,time);
    },

    //上次签到时间（单位：天）
    getQdDay:function () {
        return ELSGameTool.getInstance().getIntegerForKey("ELS_QD_day",0);
    },
    setQdDay:function (day) {
        ELSGameTool.getInstance().setIntegerForKey("ELS_QD_day",day);
    },

    //连续签到天数
    getLxQdDay:function () {
        return ELSGameTool.getInstance().getIntegerForKey("ELS_LXQD_day",0);
    },
    setLxQdDay:function (day) {
        ELSGameTool.getInstance().setIntegerForKey("ELS_LXQD_day",day);
    },

    //是否购买礼包
    isBuyGift:function (id) {
        return ELSGameTool.getInstance().getBoolForKey("ELS_GIFT_"+id,false);
    },

    //购买礼包
    buyGift:function (id,bool) {
        if(bool)
            ELSGameTool.getInstance().setBoolForKey("ELS_GIFT_"+id,true);
        else
            ELSGameTool.getInstance().setBoolForKey("ELS_GIFT_"+id,false);
    },

    //免费抽奖次数
    getFreeTurnTable:function () {
        var day=ELSGameTool.getInstance().getHistoryDay();
        if(day!=this.getMfcjDay()){
            this.setMfcjDay(day);
            this.setFreeTurnTable(20);
            return 20;
        }else{
            return ELSGameTool.getInstance().getIntegerForKey("ELS_MFCJ_NUM");
        }
    },
    setFreeTurnTable:function (num) {
        ELSGameTool.getInstance().setIntegerForKey("ELS_MFCJ_NUM",num);
    },

    getMfcjDay:function () {
        return ELSGameTool.getInstance().getIntegerForKey("ELS_MFCJ_day");
    },

    setMfcjDay:function (day) {
        ELSGameTool.getInstance().setIntegerForKey("ELS_MFCJ_day",day);
    },


});

ELSGameData._instance=null;

ELSGameData.getInstance=function(){
    if(ELSGameData._instance==null){
        ELSGameData._instance=new ELSGameData();
    }
    return ELSGameData._instance;
}