var RankLayer=BaseLayer.extend({
    _root:null,
    _listview:[],
    _btset:[],
    _page:0,
    _bt_award:null,
    ctor:function(){
        this._super();

        this.initLayer();

        ELSGameLogic.getInstance().addSingleSend(this,cc.p(570,275));
    },

    initLayer:function(){
        this._root=ccs.load(res.RankPage_ygb_json).node;
        this.getContainer().addChild(this._root);
        this._root.setContentSize(WINSIZE);
        ccui.helper.doLayout(this._root);
        this._root.setPosition(cc.p(0,-(WINSIZE.height-1136)/2));

        for(var i=0;i<3;i++){
            this._listview[i]=new RankList(this._root.getChildByName("ListView").getPosition(),i);
            this._root.addChild(this._listview[i]);
        }
        this._root.getChildByName("ListView").removeFromParent();

        this._btset[0]=wb.FW(this._root,"Button_jd",function(){
            this._page=0;
            this.turnToPage(0);
        }.bind(this));
        this._btset[1]=wb.FW(this._root,"Button_td",function(){
            this._page=1;
            this.turnToPage(1);
        }.bind(this));
        this._btset[2]=wb.FW(this._root,"Button_fk",function(){
            this._page=2;
            this.turnToPage(2);
        }.bind(this));

        this._bt_award=wb.FW(this._root,"Button_award",function () {
            this.getReward();
        }.bind(this));

        this._page=1;
        this.turnToPage(1);

        wb.FW(this._root,"cha",function(){
            ELSGameLogic.getInstance().backToMain();
        });
    },

    //领取奖励
    getReward:function () {
        ELSGameTool.getInstance().clickUm("hj_tap_rank","bonus");
        var bonusdata=RankData.getInstance()._bonuslist[this._page];
        bonusdata.liqu=true;
        var num=0;
        if(bonusdata.rewardnum.length>0)
            num=bonusdata.rewardnum[0];
        ELSGameTool.getInstance().clickUm("hj_rank","success");
        // var lay=new CommonRewardLayer(num);
        // this.addChild(lay);
        ELSGameLogic.getInstance().useIcon(num);
        ELSGameTool.getInstance().diamondMotion(num);
        this._bt_award.setTouchEnabled(false);
        this._bt_award.setBright(false);
        ELSGameData.getInstance().setRankBounsTime(this._page,bonusdata.time);
    },

    //界面跳转
    turnToPage:function(idx){
        this._page=idx;
        //按钮
        for(var i=0;i<3;i++){
            if(i==idx){
                this._btset[i].setBright(false);
                this._btset[i].setTouchEnabled(false);
                this._listview[i].setVisible(true);
            }else{
                this._btset[i].setBright(true);
                this._btset[i].setTouchEnabled(true);
                this._listview[i].setVisible(false);
            }
        }

        //顶部显示
        this.updateTopRank(idx);
    },

    //前三名和自己显示
    updateTopRank:function(idx){
        var datalist=RankData.getInstance().getRankData(idx);
        for(var i=0;i<3;i++){
            var data=datalist[49-i];
            var ranknode=this._root.getChildByName("rank"+(i+1));
            var fnt_name=ranknode.getChildByName("name");
            fnt_name.setString(data.name);
            var fnt_score=ranknode.getChildByName("score");
            fnt_score.setString(data.score);
            var fnt_touxiang=ranknode.getChildByName("image");
            fnt_touxiang.setVisible(false);
            ranknode.removeChildByTag(111);
            var image=data.image;
            if(data.isuser)
                image=GameUserInfo.getInstance().getUserTx();
            var txnode=ELSGameTool.getInstance().headImageCut(image,res.headimage_png,90);
            txnode.setPosition(fnt_touxiang.getPosition());
            ranknode.addChild(txnode,1,111);
        }

        //自己
        var selfnode=this._root.getChildByName("myMsgBG");
        var self=RankData.getInstance().getUserData(idx);
        if(self){
            selfnode.getChildByName("name").setString("自己");
            selfnode.getChildByName("score").setString("分数:"+self.score);
            var image=self.image;
            if(self.isuser)
                image=GameUserInfo.getInstance().getUserTx();
            selfnode.getChildByName("image").loadTexture(image);
            if(self.order>50){
                selfnode.getChildByName("No1").setVisible(false);
                selfnode.getChildByName("zsnode").setVisible(false);
                selfnode.getChildByName("appraise").setVisible(true);
            }else{
                selfnode.getChildByName("No1").setVisible(true);
                selfnode.getChildByName("No1").setString(self.order);
                selfnode.getChildByName("zsnode").setVisible(true);
                selfnode.getChildByName("appraise").setVisible(false);
                if(self.order==1)
                    selfnode.getChildByName("zsnode").getChildByName("zsnum").setString("x200");
                else if(self.order==2)
                    selfnode.getChildByName("zsnode").getChildByName("zsnum").setString("x100");
                else if(self.order==3)
                    selfnode.getChildByName("zsnode").getChildByName("zsnum").setString("x50");
                else if(self.order<11)
                    selfnode.getChildByName("zsnode").getChildByName("zsnum").setString("x30");
                else
                    selfnode.getChildByName("zsnode").getChildByName("zsnum").setString("x10");
            }
        }

        //领奖
        var bonusdata=RankData.getInstance()._bonuslist[idx];
        if(bonusdata.rewardid.length>0&&!bonusdata.liqu){
            this._bt_award.setTouchEnabled(true);
            this._bt_award.setBright(true);
        }else{
            this._bt_award.setTouchEnabled(false);
            this._bt_award.setBright(false);
        }

    },
});