var MainPageLayer = cc.Layer.extend({
    userTX:null,//用户头像
    userName:null,//用户昵称
    userLevel:null,//用户等级
    userLvProcess:null,//用户等级进度
    _bt_freediamond:null,   //免费钻石
    _bt_turn:null,  //转盘
    diamondNum:null,//钻石数量
    gift_newPlayer:null,//新手礼包
    gift_noAD:null,//去广告礼包
    gift_limited:null,//限时礼包
    ctor:function () {
        this._super();

        ELSGameTool.getInstance().playMusic(VIDEO[2],true);

        ELSGameData.getInstance().main_num++;

        OnezeroConfig.getInstance().loadconfig();
        this.initLayer();
        this.update(0.0);
        this.scheduleUpdate();
        ELSGameLogic.getInstance().addReturnPage(1);
   //     ELSGameLogic.getInstance().addIconSend(this);
   //     ELSGameLogic.getInstance().addSingleSend(this,cc.p(65,430));

        ELSGameTool.getInstance().getRecentDate();
    },

    initLayer:function () {
        var root = ccs.load(res.MainPageLayer_json).node;
        this.addChild(root);
        root.setContentSize(WINSIZE);
        ccui.helper.doLayout(root);

        //banner
        var banner=root.getChildByName("banner");
        banner.setVisible(false);

        //用户信息初始化
        this.userTX=ccui.helper.seekWidgetByName(root,"tx");
        this.userName=ccui.helper.seekWidgetByName(root,"name");
        this.userLevel=ccui.helper.seekWidgetByName(root,"level");
        this.diamondNum= ccui.helper.seekWidgetByName(root,"diaNum");
        this.userLvProcess= ccui.helper.seekWidgetByName(root,"lvBar");
        this.refreshUserMessage();

        //进入游戏
        var index=0;
        var btname=["Button_tg","Button_td","Button_ts","Button_jd"];
        for(var i in btname){
            var bt=ccui.helper.seekWidgetByName(root,btname[i]);
            bt.setTag(100+parseInt(i));
            bt.addTouchEventListener(function(selector, target){
                var tag=selector.getTag();
                switch(target){
                    case ccui.Widget.TOUCH_BEGAN:
                        ELSGameTool.getInstance().playVideo(VIDEO[0]);
                        selector.setScale(BUTTON_SCALE);
                        break;
                    case ccui.Widget.TOUCH_CANCELED:
                        selector.setScale(1.0);
                        break;
                    case ccui.Widget.TOUCH_ENDED:
                        selector.setScale(1.0);
                        if(tag>=100&&tag<104){
                            wb.HjTaskManager.startGame(GameName[tag-100]);
                        }
                        if(tag==100){
                            cc.director.runScene(new StarScene());
                        } else if(tag==101){
                            cc.director.runScene(new OnezeroScene());
                        }else if(tag==102){
                            cc.director.runScene(new LiujiaoScene());
                        }else if(tag==103){
                            cc.director.runScene(new TetrisScene());
                        }
                        ELSGameLogic.getInstance().openAd("banner");
                        if(tag>100){
                            cc.audioEngine.stopMusic(false);
                           // ELSGameTool.getInstance().playMusic(VIDEO[11],true);
                        }
                        ELSGameTool.getInstance().clickUm("hj_tap_home","type_"+GameName[tag-100]);
                        break;
                }
                //进入游戏时开始统计在线时长
                wb.HJCore.onEnterGame();
            });
        }

        //帮助按钮
        wb.FW(root,"Button_help",function () {
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
            var layer=new HelpLayer();
            //layer.attr({x:winSize.width/2,y:winSize.height/2});
            //layer.setPosition(cc.p(winSize.width/2,winSize.height/2));
            this.addChild(layer);
        }.bind(this));

        //头像按钮
        var bt_tx=wb.FW(root,"btn_tx",function () {
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
            ELSGameTool.getInstance().clickUm("hj_tap_home","avatar");
            var layer = new UserSetting();
            this.addChild(layer);
        }.bind(this));
        bt_tx.setPressedActionEnabled(false);

        //排行榜
        var bt_phb=wb.FW(root,"btn_rank",function(){
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
            ELSGameTool.getInstance().clickUm("hj_tap_home","Rank");
            var layer=new RankLayer();
            this.addChild(layer);
        }.bind(this));
        //bt_phb.setVisible(false);

        //免费钻石
        this._bt_freediamond=wb.FW(root,"Button_mfzs",function () {
            ELSGameTool.getInstance().clickUm("hj_tap_home","video");
            var layer = new FreeDiamondLayer();
            this.addChild(layer);
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));
        this._bt_freediamond.runAction(new cc.RepeatForever(new cc.Sequence(new cc.RotateTo(0.2,5.0),new cc.RotateTo(0.2,-5.0))));

        //大转盘
        this._bt_turn=wb.FW(root,"Button_turn",function () {
            var layer = new TurnTalbeLayer();
            this.addChild(layer);
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        //兑换码
        wb.FW(root,"Button_dhm",function () {
            var layer = new Dhmlayer();
            this.addChild(layer);
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        //签到按钮
        wb.FW(root,"Button_sign",function () {
            ELSGameTool.getInstance().clickUm("hj_tap_home","sign");
            var layer = new SignLayer();
            this.addChild(layer);
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        //任务按钮
        var bt_task=wb.FW(root,"Button_task",function () {
            ELSGameTool.getInstance().clickUm("hj_tap_home","task");
            var layer = new TaskLayer();
            this.addChild(layer);
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));
        //bt_task.setVisible(false);

        //设置按钮
        wb.FW(root,"Button_set",function () {
            ELSGameTool.getInstance().clickUm("hj_tap_home","set");
            var layer = new SettingLayer();
            this.addChild(layer);
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        //商店按钮
        bt_shop=wb.FW(root,"Button_shop",function () {
            ELSGameTool.getInstance().clickUm("hj_tap_home","shop");
            var layer = new ShopLayer();
            this.addChild(layer);
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));
        bt_shop.setVisible(false);
        if(ELSGameTool.getInstance().isGiftExist(2))
            bt_shop.setVisible(true);

        //钻石加号按钮
        bt_add=wb.FW(root,"Button_add",function () {
            ELSGameTool.getInstance().clickUm("hj_tap_home","shop");
            var layer = new ShopLayer();
            this.addChild(layer);
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));
        bt_add.setVisible(false);
        if(ELSGameTool.getInstance().isGiftExist(2))
            bt_add.setVisible(true);
        //新手礼包按钮
       this.gift_newPlayer = wb.FW(root,"Button_new",function () {
           ELSGameTool.getInstance().clickUm("hj_tap_home","gift_1");
            var layer = new GiftLayer_newPlayer();
            this.addChild(layer);
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        //去广告礼包按钮
        this.gift_noAD = wb.FW(root,"Button_noad",function () {
           // ELSGameTool.getInstance().clickUm("hj_tap_home","gift_2");
            var layer = new GiftLayer_noAD();
            this.addChild(layer);
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        //限时礼包按钮
        this.gift_limited = wb.FW(root,"Button_xs",function () {
            ELSGameTool.getInstance().clickUm("hj_tap_home","gift_1");
            var layer = new GiftLayer_limited();
            this.addChild(layer);
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        //绑定微信按钮
        var btn_wx = wb.FW(root,"btn_wx",function () {
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));
        btn_wx.setVisible(false);

        //周赛按钮
        var btn_zs = wb.FW(root,"Button_zs",function () {
            ELSGameTool.getInstance().clickUm("hj_tap_home","match");

        }.bind(this));
        btn_zs.setVisible(false);


        // var piclv=ccui.helper.seekWidgetByName(root,"piclv");
        // piclv.setVisible(false);
        // this._bt_turn.setVisible(false);
        // this._bt_freediamond.setVisible(false);
        // var set=ccui.helper.seekWidgetByName(root,"Button_set");
        // set.setVisible(false);
        // var set=ccui.helper.seekWidgetByName(root,"btn_rank");
        // set.setVisible(false);
        // var dhm=ccui.helper.seekWidgetByName(root,"Button_dhm");
        // dhm.setVisible(false);
        // this.gift_limited.setVisible(false);
        // this.gift_noAD.setVisible(false);
        // this.gift_newPlayer.setVisible(false);
    },

    //计时器函数（每帧执行）
    update:function () {
        //刷新用户信息
        this.refreshUserMessage();

        //免费钻石刷新显示
        var isAdReady=wb.ADManager.isAdReady("home_mfzs","video")
        if(isAdReady){
            this._bt_freediamond.setVisible(true);
        }else{
            this._bt_freediamond.setVisible(false);
        }

        if(!bt_shop.isVisible()){
            if(ELSGameTool.getInstance().isGiftExist(2))
                bt_shop.setVisible(true);
        }
        if(!bt_add.isVisible()){
            if(ELSGameTool.getInstance().isGiftExist(2))
                bt_add.setVisible(true);
        }

        var isAdReady2=wb.ADManager.isAdReady("rotary_mfzs","video")
        if(isAdReady2){
            this._bt_turn.setVisible(true);
        }else{
            this._bt_turn.setVisible(false);
        }

        //如果礼包已经购买或者礼包没有配置就隐藏
        this.updateGiftView(5);
        this.updateGiftView(6);
        this.updateGiftView(7);

    },

    //刷新礼包显示
    updateGiftView:function(id)
    {
        //如果礼包已经购买或者礼包没有配置就去掉
        if(!ELSGameTool.getInstance().isGiftExist(id)||(ELSGameData.getInstance().isBuyGift(id)&&id!=6))
        {
            switch(id)
            {
                case 5 :this.gift_noAD.setVisible(false);break;
                case 6 :this.gift_limited.setVisible(false);break;
                case 7 :this.gift_newPlayer.setVisible(false);break;
            }

        }

    },

    //刷新用户信息
    refreshUserMessage:function () {
        this.userTX.loadTexture(GameUserInfo.getInstance().getUserTx());
        //使用微信头像
        if(wb.WBUser.userInfo.data.wxhead.length>0)
        {
            cc.loader.loadImg(this.giftCfg.picture_url,
                {isCrossOrigin : false }, function(err, img){
                    if(img)
                    {
                        var texture2d = new cc.Texture2D();
                        texture2d.initWithElement(img);
                        texture2d.handleLoadedTexture();
                        this.userTX.loadTexture(texture2d);
                    }
                }.bind(this));
        }
        this.userName.setString(GameUserInfo.getInstance().getUserName());
        this.userLevel.setString(GameUserInfo.getInstance().getUserLevel());
        this.diamondNum.setString(ELSGameLogic.getInstance().getIcon());
    }

});



var MainScene2 = cc.Scene.extend({
    onEnter:function () {
        this._super();
        var layer = new MainPageLayer();
        this.addChild(layer,1,"layer");
    }
});