ONEZERO_SIZE_WIDTH=76;
ONEZERO_WIDTH=8;
ONEZERO_HEIGHT=8;
var OnezeroLayer=cc.Layer.extend({
    _manager:null,
    ctor:function () {
        this._super();

        ELSGameLogic.getInstance().setGameType(GameType.Type_1010);
        this.initLayer();
        this._manager=new Onezeromanager();
        this.addChild(this._manager);
        this.dataUpdate();
        this.schedule(this.dataUpdate,0.1);
        var hbpos=cc.p(145,WINSIZE.height-58);
        if(ELSGameLogic.getInstance().isFullScreen())
            hbpos.y-=FULLSCENE_HEIGHT;
        ELSGameLogic.getInstance().addLimitHb(this,hbpos);
        ELSGameLogic.getInstance().addReturnPage(2);
    },

    initLayer:function () {
        csb=ccs.load(res.OnezeroScene_json).node;
        this.addChild(csb);
        csb.setContentSize(WINSIZE);
        ccui.helper.doLayout(csb);

        var node=csb.getChildByName("node");
        if(ELSGameLogic.getInstance().isFullScreen()){
            var pos=node.getPosition();
            node.setPosition(cc.p(pos.x,pos.y-FULLSCENE_HEIGHT));
        }

        fnt_score=node.getChildByName("recentscore").getChildByName("fnt");
        fnt_highscore=node.getChildByName("hightestscore").getChildByName("fnt");

        wb.FW(node,"pause",function () {
            if(!this.getManager()._guide){
                cc.log("pause.xxx");
                var layer=new PauseLayer();
                this.addChild(layer,100);
                ELSGameTool.getInstance().playVideo(VIDEO[0]);
            }
        }.bind(this));
    },

    getManager:function () {
        return this._manager;
    },

    restart:function () {
        OneZeroTempData.getInstance().clear();
        this.getManager().restart();
    },

    dataUpdate:function (ft) {
        fnt_score.setString(this.getManager().getScore().toString());
        fnt_highscore.setString(ELSGameData.getInstance().getTdHighScore().toString());
    },
});

var OnezeroScene=cc.Scene.extend({
    onEnter:function () {
        this._super();

        var layer=new OnezeroLayer();
        this.addChild(layer,1,"layer");
    }
});
