/**
 * Created by skai1 on 2018/1/25.
 */

    //通用获得钻石界面
var CommonRewardLayer = cc.Layer.extend({

    actioning:false,
    sp_root:null,
    counts:0,
    enpos:null,
    ctor: function (counts,pos,ty) {
        this._super();
        this.actioning = false;
        this.counts = counts;

        if(!pos){
            this.enpos=cc.p(165,525+(WINSIZE.height-1136));
        }else{
            this.enpos=cc.p(pos.x-320,pos.y-WINSIZE.height/2);
        }

        var layercolor = new cc.LayerColor();
        layercolor.setOpacity(150);
        this.addChild(layercolor);

        this.sp_root =new cc.Sprite();
        this.sp_root.setPosition(cc.p(WINSIZE.width/2,WINSIZE.height/2));
        this.addChild(this.sp_root);
        var g_spine = new sp.SkeletonAnimation(wb.appendSceneStr("res/spine/djgx.json"),wb.appendSceneStr("res/spine/djgx.atlas"), 1.0);
        g_spine.setAnimation(0, "ty", true);
        this.sp_root.addChild(g_spine);
        var zuan = new cc.Sprite(wb.appendSceneStr("res/spine/diamond_icon.png"));
        zuan.setPosition(cc.p(1,-3));
        this.sp_root.addChild(zuan);
        g_spine.setTag(1);
        zuan.setTag(2);
        var num = new cc.LabelAtlas(":"+counts,wb.appendSceneStr("res/spine/num_dj_zs_fs_sj.png"),19,26,"0");
        zuan.addChild(num);
        num.setAnchorPoint(cc.p(0.5, 0.5));
        num.setPosition(zuan.getContentSize().width + 10, zuan.getContentSize().height / 4 -6);
        zuan.setScale(1.2);

        g_spine.setOpacity(0);
        g_spine.runAction(new cc.FadeTo(0.6,230));
        zuan.setScale(0);

        zuan.runAction(new cc.Sequence(new cc.DelayTime(0.05), new cc.ScaleTo(0.2,1.2),new cc.ScaleTo(0.1,0.9),
           new cc.ScaleTo(0.1,1.0)));

        cc.eventManager.addListener({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: this.onTouchBegan,
            onTouchMoved: this.onTouchMoved,
            onTouchEnded: this.onTouchEnded
        }, this);

        this.scheduleOnce(
        function(f)
        {
          this.doFlyAction();
        },1,"schedule_action");
        return true;
    },

    doFlyAction:function()
    {
        if( this.actioning )
        {
            return;
        }
        this.actioning = true;
        this.unschedule("schedule_action");
        var tar_pos = cc.p(100,1100);
        var delayTime = 0;
        var zuan_pos =  this.sp_root.getChildByTag(2).getPosition();

        var mnum=this.counts>10?10:this.counts;

        var secondpos=cc.p(-170,100);
        if(this.enpos.x<0)
            secondpos.x=170;

        for(var i =0;i <mnum;i++)
        {
            var zuan = new cc.Sprite(wb.appendSceneStr("res/spine/diamond_icon.png"));
            zuan.setPosition(cc.p(1,-3));
            this.sp_root.addChild(zuan,mnum-i);
            var beziercfg = [cc.p(1,-3),
                secondpos,
                this.enpos ];
            zuan.runAction(new cc.Sequence(new cc.DelayTime(delayTime),new cc.BezierTo(0.4,beziercfg),
            new cc.FadeTo(0.15,0)));
            delayTime += 0.15;
        }
        this.sp_root.removeChildByTag(2);
        this.sp_root.getChildByTag(1).runAction(new cc.Sequence(
            new cc.DelayTime(delayTime -0.2),new cc.FadeTo(0.2,0)));
        this.runAction(new cc.Sequence(new cc.DelayTime(delayTime + 0.4),new cc.CallFunc(function(){
            if(this.getParent()._gamemanage)
            {
                this.getParent()._gamemanage.setGameState(1);
            }
        }.bind(this)),new cc.RemoveSelf()));
    },
    onTouchBegan:function (touch, event) {
        var target = event.getCurrentTarget();
        target.doFlyAction();
        return true;
    },
    onTouchMoved:function (touch, event) {

    },
    onTouchEnded:function (touch, event) {

    }



});