var left_max_time=10;
FaildLayerTag=12345;
var FaildLayer=BaseLayer.extend({
    _hutimer:null,
    _lefttime:5,
    _hufnt:null,
    _timestop:false,
    ctor:function () {
        this._super();

        this.setName("faildlayer");
        ELSGameLogic.getInstance().openAd("level_fail");

        this.runAction(new cc.Sequence(new cc.DelayTime(0.1),new cc.CallFunc(function () {
            wb.HjTaskManager.failGame(GameName[ELSGameLogic.getInstance().getGameType()-1],this.getGameManager().getScore());
        }.bind(this))));

        this._lefttime=left_max_time;
        this.initLayer();
        this.layerMotion();

        //游戏失败时保存游戏时长
        wb.HJCore.onOutGame();

        //倒计时
        this.leftTimeUpdate(0.0);
        this.schedule(this.leftTimeUpdate,1.0);

        ELSGameLogic.getInstance().addSingleSend(this,cc.p(586,420));
        ELSGameLogic.getInstance().addIconSend(this);
    },

    getGameManager:function () {
        return this.getParent().getManager();
    },

    initLayer:function () {
        csb=ccs.load(res.FaildLayer_json).node;
        this.getContainer().addChild(csb);
        csb.setContentSize(WINSIZE);
        ccui.helper.doLayout(csb);

        //钻石复活
        wb.FW(csb,"Button_jxtg",function () {
            if(ELSGameLogic.getInstance().getIcon()>=10){
                ELSGameLogic.getInstance().useIcon(-10);
                this.gameResurrection();
            }else{
                if(ELSGameTool.getInstance().isGiftExist(2)){
                    this._timestop=true;
                    var layer=new ShopLayer();
                    this.addChild(layer,100);
                }else{
                    ELSGameTool.getInstance().gameTip("钻石不足");
                }
            }
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        //视频复活
        wb.FW(csb,"Button_mfjs",function () {
            ELSGameLogic.getInstance().openAdC("level_fail_mfzs",function(){
                this.gameResurrection();
            }.bind(this));
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        //重新开始
        // wb.FW(csb,"Button_cxks",function () {
        //     this.gameRestart();
        // }.bind(this));

        //赞
        // wb.FW(csb,"Button_zan",function () {
        //
        // });

        //叉
        wb.FW(csb,"cha",function () {
            ELSGameData.getInstance().setModelHighScore(this.getGameManager().getScore());
            ELSGameLogic.getInstance().backToMain();
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        this._hufnt=csb.getChildByName("AtlasLabel_2");
        var hudi=csb.getChildByName("time");
        this._hutimer=new cc.ProgressTimer(new cc.Sprite(res.hutimer_up));
        csb.addChild(this._hutimer);
        this._hutimer.setPosition(hudi.getPosition());
        this._hutimer.setType(cc.ProgressTimer.TYPE_RADIAL);
        this._hutimer.setReverseDirection(true);
        this._hutimer.setPercentage(100);

    },

    //倒计时
    leftTimeUpdate:function (ft) {
        if(this._timestop)
            return;
        if(this._lefttime<0){
            ELSGameData.getInstance().setModelHighScore(this.getGameManager().getScore());
            ELSGameLogic.getInstance().backToMain();
        }
        this._hufnt.setString(this._lefttime.toString());
        this._hufnt.setScale(1.0);
        this._hufnt.setOpacity(255);
        this._hufnt.runAction(new cc.ScaleTo(0.95,2.0));
        this._hufnt.runAction(new cc.FadeOut(0.95));
        this._lefttime--;
        this._hutimer.runAction(new cc.ProgressTo(1,100*this._lefttime/left_max_time));
    },

    //游戏复活
    gameResurrection:function (){
        //进入游戏开始统计在线时长
        wb.HJCore.onEnterGame();

        this.getGameManager().resurrenction();
        this.removeFromParent();
    },

    //游戏重新开始
    gameRestart:function () {
        //进入游戏开始统计在线时长
        wb.HJCore.onEnterGame();

        ELSGameData.getInstance().setModelHighScore(this.getGameManager().getScore());
        this.getParent().restart();
        this.removeFromParent();
    },

    layerMotion:function () {
         var yxjs=csb.getChildByName("Button_jxtg");
         var mfjs=csb.getChildByName("Button_mfjs");
         // var cxks=csb.getChildByName("Button_cxks");
         // var zan=csb.getChildByName("Button_zan");
         var cancel=csb.getChildByName("cha");
         yxjs.setVisible(false);
         mfjs.setVisible(false);
         // cxks.setVisible(false);
         // zan.setVisible(false);

         // if(cc.sys.os!=cc.sys.IOS){
         //     cxks.setPositionX(WINSIZE.width/2);
         // }

        var isready=wb.ADManager.isAdReady("level_fail_mfzs");
        if(isready){
            this.menuMotion(mfjs);
            this.runAction(new cc.Sequence(new cc.DelayTime(1.5),new cc.CallFunc(function () {
                this.menuMotion(yxjs);
            }.bind(this)),new cc.DelayTime(1.5),new cc.CallFunc(function () {
             //   this.menuMotion(cxks);
             //    if(cc.sys.os==cc.sys.IOS)
             //        this.menuMotion(zan);
            }.bind(this))));
        }else{
            var pos1=yxjs.getPosition();
            var pos2=mfjs.getPosition();
            yxjs.setPosition(cc.p((pos1.x+pos2.x)/2,(pos1.y+pos2.y)/2));
            this.menuMotion(yxjs);
            // this.runAction(new cc.Sequence(new cc.DelayTime(1.5), new cc.CallFunc(function () {
            //     this.menuMotion(cxks);
            //     if(cc.sys.os==cc.sys.IOS)
            //         this.menuMotion(zan);
            // }.bind(this))));
        }
    },

    menuMotion:function (bt) {
        bt.setVisible(true);
        bt.setScale(0.0);
        bt.runAction(new cc.Sequence(new cc.ScaleTo(0.2,1.05),new cc.ScaleTo(0.1,1.0)));
    },
})