//限时礼包
var GiftLayer_limited = BaseLayer.extend({
    ctor:function () {
        this._super();
        this.initLayer();
    },

    initLayer:function () {

        var root = ccs.load(res.gift_limited_json).node;
        this.getContainer().addChild(root);

        //礼包价格
        var price = ccui.helper.seekWidgetByName(root,"money");
        price.setString("￥"+ ZSPRICE[5]/100 + ".00");
        price.setTextHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER);

        //奖励钻石
        var diamond = ccui.helper.seekWidgetByName(root,"diaNum");
        diamond.setString(ZSNUM[5].toString());
        diamond.setTextHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER);

        //关闭按钮
        wb.FW(root,"Button_Cancel",function () {
            this.removeFromParent(true);
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        //购买按钮
        wb.FW(root,"Button_Lingqu",function () {

            ELSGameLogic.getInstance().orderPay(6);
            this.removeFromParent(true);
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));
    },

});

//新手礼包
var GiftLayer_newPlayer = BaseLayer.extend({
    ctor:function () {
        this._super();
        this.initLayer();
    },

    initLayer:function () {

        var root = ccs.load(res.gift_newPlayer_json).node;
        this.getContainer().addChild(root);

        //礼包价格
        var price = ccui.helper.seekWidgetByName(root,"money");
        price.setString("￥"+ ZSPRICE[6]/100 + ".00");
        price.setTextHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER);

        //奖励钻石
        var diamond = ccui.helper.seekWidgetByName(root,"diaNum");
        diamond.setString(ZSNUM[6]);
        diamond.setTextHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER);

        //关闭按钮
        wb.FW(root,"Button_Cancel",function () {
            this.removeFromParent(true);
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        //购买按钮
        wb.FW(root,"Button_Lingqu",function () {

            ELSGameLogic.getInstance().orderPay(7);
            this.removeFromParent(true);
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));
    },

});

//去广告礼包
var GiftLayer_noAD = BaseLayer.extend({
    ctor:function () {
        this._super();
        this.initLayer();
    },

    initLayer:function () {

        var root = ccs.load(res.gift_noAD_json).node;
        this.getContainer().addChild(root);

        //礼包价格
        var price = ccui.helper.seekWidgetByName(root,"money");
        price.setString("￥"+ ZSPRICE[4]/100 + ".00");
        price.setTextHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER);

        //奖励钻石
        var diamond = ccui.helper.seekWidgetByName(root,"diaNum");
        diamond.setString(ZSNUM[4]);
        diamond.setTextHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER);

        //关闭按钮
        wb.FW(root,"Button_Cancel",function () {
            this.removeFromParent(true);
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        //购买按钮
        wb.FW(root,"Button_Lingqu",function () {

            ELSGameLogic.getInstance().orderPay(5);
            this.removeFromParent(true);
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));
    },

});