var SettingLayer =  BaseLayer.extend({
    ctor:function () {
        this._super();
        this.initLayer();

        ELSGameLogic.getInstance().addSingleSend(this,cc.p(586,420));
    },

    initLayer:function () {

        var root = ccs.load(res.settingLayer_json).node;
        this.getContainer().addChild(root);

        var bg=ccui.helper.seekWidgetByName(root,"bg");
        var pic=bg.getChildByName("picture");
        ELSGameLogic.getInstance().addRectSend(bg,pic.getPosition());

        //关闭按钮
        wb.FW(root,"cha",function () {
            this.removeFromParent(true);
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        //用户设置按钮
        var bt_user=wb.FW(root,"btn_user",function () {
            ELSGameTool.getInstance().clickUm("hj_tap_set","user");
            var layer = new UserSetting();
            this.addChild(layer,100);
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        //分享评分按钮
        var bt_share=wb.FW(root,"btn_share",function () {
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
            ELSGameTool.getInstance().clickUm("hj_tap_set","Share");
            ELSGameTool.getInstance().clickUm("hj_share","success");
        }.bind(this));
        bt_share.setVisible(false);

        bt_user.setPositionY(bt_share.getPositionY());

        //主题按钮
        var bt_theme=wb.FW(root,"btn_theme",function () {
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));
        bt_theme.setVisible(false);

        //帮助按钮
        wb.FW(root,"Button_help",function () {
            ELSGameTool.getInstance().clickUm("hj_tap_set","Help");
            var layer = new HelpLayer();
            this.addChild(layer,100);
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        //音乐复选框
        Button_musicon=ccui.helper.seekWidgetByName(root,"Button_musicon");
        Button_musicon.addClickEventListener(function () {
            ELSGameTool.getInstance().clickUm("hj_tap_set","Music");
            Button_musicon.setVisible(false);
            Button_musicoff.setVisible(true);
            wb.setMusicEnable(false);
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
            cc.audioEngine.stopMusic(false);
        });
        Button_musicoff=ccui.helper.seekWidgetByName(root,"Button_musicoff");
        Button_musicoff.addClickEventListener(function () {
            ELSGameTool.getInstance().clickUm("hj_tap_set","Music");
            Button_musicon.setVisible(true);
            Button_musicoff.setVisible(false);
            wb.setMusicEnable(true);
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
            ELSGameTool.getInstance().playMusic(VIDEO[2],true);
        });
        if(wb.getMusicEnable()){
            Button_musicon.setVisible(true);
            Button_musicoff.setVisible(false);
        }else{
            Button_musicon.setVisible(false);
            Button_musicoff.setVisible(true);
        }

        //音效复选框
        Button_videoon=ccui.helper.seekWidgetByName(root,"Button_videoon");
        Button_videoon.addClickEventListener(function () {
            ELSGameTool.getInstance().clickUm("hj_tap_set","sound");
            Button_videoon.setVisible(false);
            Button_videooff.setVisible(true);
            wb.setSoundEnable(false);
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        });
        Button_videooff=ccui.helper.seekWidgetByName(root,"Button_videooff");
        Button_videooff.addClickEventListener(function () {
            ELSGameTool.getInstance().clickUm("hj_tap_set","sound");
            Button_videoon.setVisible(true);
            Button_videooff.setVisible(false);
            wb.setSoundEnable(true);
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        });
        if(wb.getSoundEnable()){
            Button_videoon.setVisible(true);
            Button_videooff.setVisible(false);
        }else{
            Button_videoon.setVisible(false);
            Button_videooff.setVisible(true);
        }

    },
    //音乐按钮回调
    btnMusicCallBack:function (sender,type) {
        switch(type){
            case ccui.CheckBox.EVENT_SELECTED:
                wb.setMusicEnable(false);
                audioEngine.stopMusic(false);
                break;
            case ccui.CheckBox.EVENT_UNSELECTED:
                wb.setMusicEnable(true);
                ELSGameTool.getInstance().playMusic(VIDEO[2]);
                break;
            default:
                break;
        }
    },
    //音效按钮回调
    btnSoundCallBack:function (sender,type) {
        switch(type){
            case ccui.CheckBox.EVENT_SELECTED:
                wb.setSoundEnable(false);
                break;
            case ccui.CheckBox.EVENT_UNSELECTED:
                wb.setSoundEnable(true);
                break;
            default:
                break;
        }
    },
});