//限时礼包
var SignLayer = BaseLayer.extend({
    signItems:null,
    btn_sign:null,
    ctor:function () {
        this._super();
        this.initLayer();
    },

    initLayer:function () {

        var root = ccs.load(res.signLayer_json).node;
        this.getContainer().addChild(root);

        //关闭按钮
        wb.FW(root,"cha",function () {
            this.removeFromParent(true);
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        //签到按钮
       this.btn_sign = wb.FW(root,"btn_sign",function () {
           ELSGameTool.getInstance().clickUm("hj_tap_sign","sign");
           ELSGameTool.getInstance().clickUm("hj_sign","success_1");
            var curDay = ELSGameTool.getInstance().getHistoryDay();
            ELSGameData.getInstance().setQdDay(curDay);
            var lxQDTime = ELSGameData.getInstance().getLxQdDay();
            switch(lxQDTime){
                case 0:ELSGameTool.getInstance().diamondMotion(5);
                    ELSGameLogic.getInstance().useIcon(5);break;
                case 1:ELSGameTool.getInstance().diamondMotion(10);
                    ELSGameLogic.getInstance().useIcon(10);break;
                case 2:ELSGameTool.getInstance().diamondMotion(20);
                    ELSGameLogic.getInstance().useIcon(20);break;
                case 3:ELSGameTool.getInstance().diamondMotion(30);
                    ELSGameLogic.getInstance().useIcon(30);break;
                case 4:ELSGameTool.getInstance().diamondMotion(40);
                    ELSGameLogic.getInstance().useIcon(40);break;
                case 5:ELSGameTool.getInstance().diamondMotion(50);
                    ELSGameLogic.getInstance().useIcon(50);break;
                case 6:ELSGameTool.getInstance().diamondMotion(100);
                    ELSGameLogic.getInstance().useIcon(100);break;
            }
            GameUserInfo.getInstance().setIsUserSigned(true);
           //刷新UI
           this.updateUI();
           ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        var node = ccui.helper.seekWidgetByName(root,"node");
        this.signItems = node.getChildren();
        //UI初始化
        this.updateUI();
    },

    //刷新UI
    updateUI:function () {
        this.initLxQdDay();
        //判断签到状态
        var lxQD_day = ELSGameData.getInstance().getLxQdDay();//连续签到天数
        for(var i in this.signItems)
        {
            if(i<lxQD_day)
            {
                this.signItems[i].setScale9Enabled(false);
                this.signItems[i].loadTexture(signpng[0]);
                this.signItems[i].setScale9Enabled(true);
                this.signItems[i].getChildByName("yes").setVisible(true);
                this.signItems[i].getChildByName("diamond").loadTexture(signpng[3]);
            }
            if(i==lxQD_day)
            {   //修改当天可签到显示
                this.signItems[i].setScale9Enabled(false);
                this.signItems[i].loadTexture(signpng[1]);
                this.signItems[i].setScale9Enabled(true);
                this.signItems[i].getChildByName("yes").setVisible(false);
                this.signItems[i].getChildByName("diamond").loadTexture(signpng[4]);
            }
            else if(i>lxQD_day)
            {
                this.signItems[i].setScale9Enabled(false);
                this.signItems[i].loadTexture(signpng[2]);
                this.signItems[i].setScale9Enabled(true);
                this.signItems[i].getChildByName("yes").setVisible(false);
                this.signItems[i].getChildByName("diamond").loadTexture(signpng[4]);
            }
            if(GameUserInfo.getInstance().getIsUserSigned())//如果已经签到就变灰色
            {
                this.signItems[lxQD_day].setScale9Enabled(false);
                this.signItems[lxQD_day].loadTexture(signpng[0]);
                this.signItems[lxQD_day].setScale9Enabled(true);
                this.signItems[lxQD_day].getChildByName("yes").setVisible(true);
                this.signItems[lxQD_day].getChildByName("diamond").loadTexture(signpng[3]);
            }
        }
        var curTime = ELSGameTool.getInstance().getHistoryDay();
        var lastTime = ELSGameData.getInstance().getQdDay();
        if(curTime==lastTime)
        {
            //禁用按钮
            this.btn_sign.setTouchEnabled(false);
            this.btn_sign.setBright(false) ;
        }
    },

    //连续签到天数初始化
    initLxQdDay:function () {
        var curTime = ELSGameTool.getInstance().getHistoryDay();
        var lastTime = ELSGameData.getInstance().getQdDay();
        if(curTime-lastTime==1)
        {
            var lxQDTime = ELSGameData.getInstance().getLxQdDay();
            if(GameUserInfo.getInstance().getIsUserSigned())
            {
                GameUserInfo.getInstance().setIsUserSigned(false);
                if(lxQDTime==6)
                {
                    lxQDTime = 0;
                }
                else {
                    lxQDTime += 1;
                }
                ELSGameData.getInstance().setLxQdDay(lxQDTime);
            }
        }
        if(curTime-lastTime>1||curTime-lastTime<0)
        {
            ELSGameData.getInstance().setLxQdDay(0);
            GameUserInfo.getInstance().setIsUserSigned(false);
        }
    }
});