var TurnProbKey=[15,5,15,5,15,10,15,20];
var TurnTypeKey=[2,1,2,1,2,1,2,1];
var TurnNumKey=[10,8,10,5,10,2,10,1];
var TurnTalbeLayer=BaseLayer.extend({
    _diamondnum:null,
    _bt_mfcj:null,
    _bt_nomfcj:null,
    _fnt_cishu:null,
    _sp:[],
    _rewardid:0,
    ctor:function () {
        this._super();

        this.initLayer();
        this.update(0.0);
        this.scheduleUpdate();
    },

    initLayer:function(){
        root=ccs.load(res.TurnTable_json).node;
        this.getContainer().addChild(root);
        root.setContentSize(WINSIZE);
        ccui.helper.doLayout(root);
        //root.setPosition(cc.p(0,-(WINSIZE.height-1136)/2));


        wb.FW(root,"cha",function () {
            this.removeFromParent();
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        diamondnum=root.getChildByName("diamondnum");
        this._diamondnum=diamondnum.getChildByName("num");
        this._diamondnum.setString(ELSGameLogic.getInstance().getIcon().toString());

        var adddiamond=diamondnum.getChildByName("add");
        adddiamond.addClickEventListener(function () {
            var layer=new ShopLayer();
            this.addChild(layer,100);
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));
        if(!ELSGameTool.getInstance().isGiftExist(2))
            adddiamond.setVisible(false);

        var mfcj=root.getChildByName("mfcj");
        this._bt_mfcj=mfcj.getChildByName("menu_1");
        this._bt_nomfcj=mfcj.getChildByName("menu_2");
        this._bt_mfcj.addClickEventListener(function () {
            this._bt_mfcj.setVisible(false);
            this._bt_nomfcj.setVisible(true);
            this.tableCallBack();
            ELSGameTool.getInstance().playVideo(VIDEO[0]);
        }.bind(this));

        this._fnt_cishu=root.getChildByName("node").getChildByName("tab_back").getChildByName("turnshow").getChildByName("num");
        var dd=ELSGameData.getInstance().getFreeTurnTable();
        this._fnt_cishu.setString(ELSGameData.getInstance().getFreeTurnTable().toString());

        this._rewardid=0;
        for(var i =0;i<8;i++){
            this._sp[i]=root.getChildByName("node").getChildByName("tab_back").getChildByName("reward_"+(i+1));
            if(i==0){
                this._sp[i].getChildByName("shade").setVisible(false);
            }else{
                this._sp[i].getChildByName("back").setVisible(false);
            }
        }

        this.updateBt();

    },

    tableCallBack:function () {
        var prop=0;
        var key=wb.randNum(0,99);
        var tempkey=0;
        for(var i=0;i<8;i++){
            tempkey+=TurnProbKey[i];
            if(key<tempkey){
                prop=i;
                break;
            }
        }

        var addprop=prop-this._rewardid;
        var action=[];
        for(var i=0;i<6;i++){
            action.push(new cc.DelayTime(0.3-(i*0.05)));
            action.push(new cc.CallFunc(function () {
                this.menuchange();
            }.bind(this)));
        }
        for(var i=0;i<(44+addprop);i++){
            action.push(new cc.DelayTime(0.05));
            action.push(new cc.CallFunc(function () {
                this.menuchange();
            }.bind(this)));
        }
        for(var i=0;i<6;i++){
            action.push(new cc.DelayTime(0.05+(i*0.05)));
            action.push(new cc.CallFunc(function () {
                this.menuchange();
            }.bind(this)));
        }
        action.push(new cc.DelayTime(0.5));
        action.push(new cc.CallFunc(function () {
            this.tableReward();
        }.bind(this)));
        this.runAction(new cc.Sequence(action));

    },

    menuchange:function () {
        this._sp[this._rewardid].getChildByName("shade").setVisible(true);
        this._sp[this._rewardid].getChildByName("back").runAction(new cc.FadeOut(0.2));
        this._sp[(this._rewardid+1)%8].getChildByName("shade").setVisible(false);
        this._sp[(this._rewardid+1)%8].getChildByName("back").stopAllActions();
        this._sp[(this._rewardid+1)%8].getChildByName("back").setOpacity(255);
        this._sp[(this._rewardid+1)%8].getChildByName("back").setVisible(true);
        this._rewardid=(this._rewardid+1)%8;
     },

    tableReward:function () {
        ELSGameData.getInstance().setFreeTurnTable(ELSGameData.getInstance().getFreeTurnTable()-1);
        var type=TurnTypeKey[this._rewardid];
        var num=TurnNumKey[this._rewardid];
        var targetpos=diamondnum.getPosition();
        targetpos.x-=60;
        targetpos.y-=5;
        if(type==1){
            ELSGameLogic.getInstance().useIcon(num);
            ELSGameTool.getInstance().diamondMotion(num,targetpos);
        }else if(type==2){
            ELSGameLogic.getInstance().openAdC("rotary_mfzs",function () {
                ELSGameLogic.getInstance().useIcon(num);
                ELSGameTool.getInstance().diamondMotion(num,targetpos);
            });
        }
        this.updateBt();
    },

    updateBt:function () {
        var adready=wb.ADManager.isAdReady("rotary_mfzs","video");
        if(adready&&ELSGameData.getInstance().getFreeTurnTable()>0){
            this._bt_nomfcj.setVisible(false);
            this._bt_mfcj.setVisible(true);
        }else{
            this._bt_nomfcj.setVisible(true);
            this._bt_mfcj.setVisible(false);
        }
    },

    update:function (ft) {
        this._diamondnum.setString(ELSGameLogic.getInstance().getIcon().toString());
        this._fnt_cishu.setString(ELSGameData.getInstance().getFreeTurnTable().toString());
    },
})