var GameUserInfo = cc.Class.extend({
    name:null,//用户昵称
    tx:null,//用户头像
    level:null,//用户等级
    sex:null,//用户性别
    id:null,//用户ID
    phone:null,//用户手机
    diamond:null,//用户钻石
    isSigned:null,//是否签到
    isShopGiftChenged:null,//商店礼包是否刷新
    ctor:function () {

        if(wb.WBUser.userInfo.data.name.length>0)
        {
            this.name = wb.WBUser.userInfo.data.name;
        }
        else {
            this.name = wb.WBUser.userInfo.data.name="柠萌";
        }

        if(wb.WBUser.userInfo.data.head.length>0)
        {
            this.tx = wb.WBUser.userInfo.data.head;
        }
        else {
            this.tx = wb.WBUser.userInfo.data.head = touxiangpng[0];
        }
        if(!wb.WBUser.userInfo.data.lv)
        {
            this.level = 0;
        }
        else {
            this.level = wb.WBUser.userInfo.data.lv;
        }

        this.sex =  wb.WBUser.userInfo.data.sex;
        this.id = wb.WBUser.userInfo.data.id;
        this.phone = wb.WBUser.userInfo.data.phone_num;
        if(!wb.WBUser.userInfo.data.diamond)
        {
            this.diamond =0;
        }else {
            this.diamond = wb.WBUser.userInfo.data.diamond;
        }

        this.isSigned =ELSGameTool.getInstance().getBoolForKey("IsSigned",false);
        this.isShopGiftChenged = ELSGameTool.getInstance().getBoolForKey("IsShopGiftChenged",false);
    },

    //获取用户头像
    getUserTx:function () {
        this.ctor();
        return this.tx;
    },

    setUserTx:function (index) {
        if(!index) return;
        wb.WBUser.userInfo.data.head = touxiangpng[index];
        wb.WBUser.changedInfo();
    },
    //获取头像Index
    getUserTxIndex:function () {
        return ELSGameTool.getInstance().getIntegerForKey("TxIndex",0);
    },
    setUserTxIndex:function (index) {
        ELSGameTool.getInstance().setIntegerForKey("TxIndex",index);
    },

    //获取用户昵称
    getUserName:function () {
        this.ctor();
        return this.name;
    },

    // setUserName:function (name) {
    //     wb.WBUser.userInfo.data.name=name;
    //     wb.WBUser.changedInfo();
    // },

    //获取用户等级
    getUserLevel:function () {
        this.ctor();
        return this.level;
    },

    //获取用户性别
    getUserSex:function () {
        this.ctor();
        return this.sex;
    },

    setUserSex:function (sex) {
        if(!sex) return;
        wb.WBUser.userInfo.data.sex = sex;
        wb.WBUser.changedInfo();
    },

    //获取用户ID
    getUserID:function () {
        this.ctor();
        return  this.id ;
    },

    //获取用户手机
    getUserPhone:function () {
        this.ctor();
        return this.phone ;
    },

    setUserPhone:function (phone) {
        if(!phone) return;
        wb.WBUser.userInfo.data.phone_num = phone;
        wb.WBUser.changedInfo();
    },

    //获取用户钻石数量
    getUserDiamond:function () {
        this.ctor();
        return this.diamond;
    },

    addUserDiamond:function (num) {
        if(!num) return;
        wb.WBUser.userInfo.data.diamond += num;
        wb.WBUser.changedInfo();
    },
    //获取签到信息
    getIsUserSigned:function () {
      return ELSGameTool.getInstance().getBoolForKey("IsSigned",false);
    },
    setIsUserSigned:function (bool) {
        ELSGameTool.getInstance().setBoolForKey("IsSigned",bool);
    },

    //获取礼包刷新
    getIsShopGiftChenged:function () {
        return ELSGameTool.getInstance().getBoolForKey("IsShopGiftChenged",false);
    },
    setIsShopGiftChenged:function (bool) {
        ELSGameTool.getInstance().setBoolForKey("IsShopGiftChenged",bool);
    }
});

GameUserInfo._instance = null;//单例

//获取单例
GameUserInfo.getInstance=function(){
    if(!GameUserInfo._instance)
    {
        GameUserInfo._instance = new GameUserInfo();
    }
    return GameUserInfo._instance;
};